#!/usr/bin/python
# Copyright (C) 2005 shinGETsu Project.
#
# $Id: test.py,v 1.5 2005/05/15 14:10:40 fuktommy Exp $
#

import os
import socket
import sys
import urllib

__version__ = "$Revision: 1.5 $"

sys.path.append("..")

import shingetsu.config


def test_apollo():
    import shingetsu.apollo
    (pubkey, prikey) = shingetsu.apollo.key_pair("abcdefgh")
    return pubkey.startswith("HFYd4FUjxeXPcdebrhJac4s/dEDN7Yp9") and \
           prikey.startswith("R7Cncv9MnBXm4LEp9/9oT7MT0UxDTIoL")

def test_httpd():
    import shingetsu.httpd
    httpd = shingetsu.httpd.Httpd()
    httpd.setDaemon(True)
    os.chdir("..")
    httpd.start()

    socket.setdefaulttimeout(shingetsu.config.timeout)
    try:
        u = urllib.urlopen("http://www.genie.x0.com/gtl/help/port_scan.php?" +
                           "port=" + str(shingetsu.config.port))
        buf = u.read()
        u.close()
        return buf.find("(\xA5\x81\xCD\xA5) \x90\xAC\x8C\xF7") > 0
    except IOError:
        return False

def main():
    if test_apollo():
        print "Apollo OK"
    else:
        print "Apollo NG"

    if test_httpd():
        print "HTTPD OK"
    else:
        print "HTTPD NG"

if __name__ == "__main__":
    main()
